const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const agent_skill_assignments = sequelize.define(
    'agent_skill_assignments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

proficiency: {
        type: DataTypes.INTEGER,
      
      

      },

is_primary: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  agent_skill_assignments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



























//end loop



    db.agent_skill_assignments.belongsTo(db.ai_agents, {
      as: 'agent',
      foreignKey: {
        name: 'agentId',
      },
      constraints: false,
    });

    db.agent_skill_assignments.belongsTo(db.agent_skills, {
      as: 'skill',
      foreignKey: {
        name: 'skillId',
      },
      constraints: false,
    });

    db.agent_skill_assignments.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.agent_skill_assignments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.agent_skill_assignments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return agent_skill_assignments;
};


